{u_main.pas - FASTA_BLAST_Scan

 	Copyright (C) 1997-2011 Olivier Friard
        (annhyb @ gmail.com)

  This file is part of FASTA_BLAST_Scan.

FASTA_BLAST_Scan is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

FASTA_BLAST_Scan is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with FASTA_BLAST_Scan; see the file COPYING.TXT.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit u_main;

interface

uses inifiles,strutils,
  SysUtils, Types, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, ExtCtrls, IdBaseComponent,
  IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

type
  TfrmMain = class(TForm)
    MainMenu1: TMainMenu;
    Sequences1: TMenuItem;
    LoadFASTAresults1: TMenuItem;
    N3: TMenuItem;
    mi_Saveselectedsequences: TMenuItem;
    N2: TMenuItem;
    Quit1: TMenuItem;
    Selection1: TMenuItem;
    SUS1: TMenuItem;
    Font1: TMenuItem;
    Help1: TMenuItem;
    Info1: TMenuItem;
    N4: TMenuItem;
    Contents1: TMenuItem;
    About1: TMenuItem;
    lv: TListView;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    lv_popupmenu: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    sb: TStatusBar;
    N5: TMenuItem;
    Selectallsequences1: TMenuItem;
    Unselectallsequences1: TMenuItem;
    Invertselection1: TMenuItem;
    mi_SaveselectedsequencesinFASTACONVformat: TMenuItem;
    IdHTTP1: TIdHTTP;
    N1: TMenuItem;
    Downloadsequenceinformation1: TMenuItem;
    N6: TMenuItem;
    Retrievemoreinfoforallsequences1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Load(Sender: TObject);
    procedure Quit1Click(Sender: TObject);
    procedure mi_SaveselectedsequencesClick(Sender: TObject);
    procedure SUS1Click(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lvClick(Sender: TObject);
    procedure Selectallsequences1Click(Sender: TObject);
    procedure Unselectallsequences1Click(Sender: TObject);
    procedure Invertselection1Click(Sender: TObject);
    procedure RetrieveInfoSelSeq(Sender: TObject);
    procedure mi_SaveselectedsequencesinFASTACONVformatClick(
      Sender: TObject);
    procedure Retrievemoreinfoforallsequences1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const maxseq=10000;   /// numero massimo di sequenze
      program_name='FASTA BLAST scan';
      version_number='2.4';
      version_date='September 28, 2011';

var frmMain: TfrmMain;
    nom_input,nq:string;
    f,f2,f3:Tstringlist;
    blasttype,fastatype,nseq,ls:integer;
    versionAlg:shortstring;
    posit:array[1..maxseq] of ^integer;
    itm:tlistitem;
    IniFile:TIniFile;
    flagparam:boolean;

procedure compte;

implementation

uses u_about, u_warning, u_select, u_options, Unit1;

{$R *.dfm}


procedure compte; //count number of selected sequences
var w:integer;
    compt:integer;
begin
compt:=0;
with frmMain do
    begin
    for w:=0 to lv.items.count-1 do
        if lv.items[w].checked then
           inc(compt);
    sb.Panels[1].Text:='Selected: '+inttostr(compt);
    end;
end; //count

procedure TfrmMain.About1Click(Sender: TObject);
begin
frmabout.lb_version.caption:='version '+version_number+' ('+version_date+')';
frmabout.showmodal;
end;



function lit_score(ss,s:shortstring):shortstring;
var r:shortstring;
    i,j:integer;
    flagok:boolean;
begin
r:='';
flagok:=false;
i:=pos(ss,s)+length(ss);
for j:=i to length(s) do
    begin
    if s[j] in ['0'..'9','-','+','E'] then
       flagok:=true;
    if flagok and (s[j]=' ') then
       begin
       flagok:=false;
       break;
       end;
    if flagok  then
       r:=r+s[j];
    end;
result:=r;
end;  //lit score

procedure removeHTMLtag(var sl:tstringlist);
var s,s2:string;
    t,i:integer;
    flagin:boolean;
begin
for t:=0 to sl.count-1 do
    begin
    s:=sl[t];
    flagin:=false;
    s2:='';
    for i:=1 to length(s) do
        begin
        if s[i]='<' then
           flagin:=true;
        if not flagin then
           s2:=s2+s[i];
        if s[i]='>' then
           flagin:=false;
        end;
    while pos('&gt;',s2)<>0 do     //replace &gt; by ">"
       begin
       insert('>',s2,pos('&gt;',s2));
       delete(s2,pos('&gt;',s2),4);
       end;
    sl[t]:=s2;
    end;
end; //remove HTML tag

procedure TfrmMain.Load(Sender: TObject);
var s,s1,s2:string;
    align,init1,initn,opt,zscore,e,ac,id,de:shortstring;
    w,erreur:integer;
    flagHTML:boolean;

procedure loadFASTA;
var w,n1:integer;
begin
//look for 'FASTA' file
fastatype:=0;
blasttype:=0;
//control HTML
flagHTML:=false;
for w:=0 to f.count-1 do
   if (pos('<HTML>',ansiuppercase(f[w]))<>0)
       or (pos('<HTTP://',ansiuppercase(f[w]))<>0) then
      begin
      flagHTML:=true;
      break;
      end;
if flagHTML then
  removeHTMLtag(f);

//extraction version info
versionAlg:='';
for w:=0 to f.count-1 do
    if pos('version ',f[w])<>0 then
       begin
       versionAlg:=copy(f[w],pos('version ',f[w]),255);
       break;
       end;

s2:='';
w:=0;
while w<=f.Count-1 do
    begin
    if (pos('(Nucleotide) FASTA',f[w])<>0) or (pos('(Peptide) FASTA',f[w])<>0)  then
        begin
        fastatype:=1;
        //version prog
        versionAlg:='FASTA from GCG package';
        // extraction nom query
        nq:=copy(f[w],pos('of: ',f[w])+4,80);
        nq:=copy(nq,1,pos(' ',nq)-1);
        // extraction longueur query
        s:=copy(f[w],pos(' from: ',f[w])+7,80);
        s:=copy(s,1,pos(' ',s)-1);
        s2:=copy(f[w],pos(' to: ',f[w])+5,20);
        s2:=copy(s2,1,pos(' ',s2)-1);
        ls:=strtoint(s2)-strtoint(s)+1;
        break;
        end;
    if (pos('FASTA searches a protein or DNA sequence data bank',f[w])<>0)
            (*or (pos('SSEARCH searches a sequence database',f[w])<>0)*) then
        begin
        fastatype:=2;   //pearson
        //extract query length
        while w<=f.count-1 do
            begin
            if (pos(' nt',f[w])=length(f[w])-2) then
               begin
               s2:=copy(f[w],pos(', ',f[w])+2,255);
               s2:=copy(s2,1,pos(' nt',s2)-1);
               nq:=copy(f[w],1,pos(',',f[w])-1);
               break;
               end;
            inc(w);
            end;
        end;
    inc(w);
    end;

if s2='' then //unknown query length
    repeat
       s2:=inputbox('Query length','Input the query length','');
       val(s2,ls,erreur);
       if (erreur<>0) or (ls=0) then
          showmessage('Input a numeric positive value!');
    until ls<>0;

ls:=strtoint(s2);
if fastatype=0 then
  begin
  Screen.Cursor := crDefault;
  showmessage('FASTA output not recognized!'#10'Check FASTA output');
  exit;
  end;
//reconnaissance sequences

w:=0;
while (pos('best',f[w])=0) or (pos('scores',f[w])=0) do
  begin
  inc(w);
  if w=f.count-1 then
     break;
  end;
if w=f.count-1 then
  begin
  Screen.Cursor:=crDefault;
  showmessage('First alignment not found!'+#10+'Check the FASTA output.');
  exit;
  end;
//reprage squences
nseq:=0;
if fastatype=1 then   //gcg
  begin
  while w<=f.count-1 do
      begin
      if (f[w]=nq) or (f[w]=nq+' /rev') then
          begin
          inc(nseq);
          new(posit[nseq]);
          posit[nseq]^:=w+3;
          end;
      inc(w);
      end;
  new(posit[nseq+1]);
  posit[nseq+1]^:=f.count;
  end;

if fastatype=2 then        //pearson
  begin
  while w<=f.count-1 do
      begin
      if (copy(f[w],1,2)='>>') then
          begin
          inc(nseq);
          new(posit[nseq]);
          posit[nseq]^:=w;
          end;
      inc(w);
      end;
  new(posit[nseq+1]);
  posit[nseq+1]^:=f.count;
  end;

// visualisation sequences
lv.items.clear;
case fastatype of 1:for n1:=1 to nseq do    //gcg
                       begin
                       s1:='';
                       s2:='';
                       s:=f[posit[n1]^];
                       itm:=lv.items.add;
                       itm.caption:=inttostr(n1);     //numro de la seq.

                       if pos('ID   ',s)<>0 then //embl
                          begin
                          itm.subitems.add(copy(s,6,255));    //1re lign ID seq.
                          w:=1;
                          s1:='';
                          s2:='';
                          ac:='';
                          de:='';
                          while pos('SCORES',f[posit[n1]^+w])=0 do
                             begin
                             if pos('AC   ',f[posit[n1]^+w])=1 then
                                ac:=ac+' '+trim(copy(f[posit[n1]^+w],6,80));
                                //s1:=trim(copy(f[posit[n1]^+w],6,80));
                             if pos('DE   ',f[posit[n1]^+w])=1 then
                                de:=de+' '+trim(copy(f[posit[n1]^+w],6,80));
                                //s2:=trim(copy(f[posit[n1]^+w],6,80));
                             inc(w);
                             end;
                          //lecture Scores
                          init1:=lit_score('INIT1:',ansiuppercase(f[posit[n1]^+w]));
                          initn:=lit_score('INITN:',ansiuppercase(f[posit[n1]^+w]));
                          opt:=lit_score('OPT:',ansiuppercase(f[posit[n1]^+w]));
                          zscore:=lit_score('ZSCORE:',ansiuppercase(f[posit[n1]^+w]));
                          e:=lit_score('E():',ansiuppercase(f[posit[n1]^+w]));
                          inc(w);
                          while pos('% identity ',f[posit[n1]^+w])=0 do
                              inc(w);
                          itm.subitems.add(trim(copy(ac,1,pos(';',ac)-1)));
                          itm.subitems.add(de);
                          //extraction homologie
                          itm.subitems.add(trim(copy(f[posit[n1]^+w],1,pos('%',f[posit[n1]^+w])-1)));
                          //extraction longueur
                          itm.subitems.add(trim(lit_score(' IN ',ansiuppercase(f[posit[n1]^+w]))));
                          end;
                       if pos(' LOCUS ',s)<>0 then    //genbank
                          begin
                          w:=1;
                          s1:='';
                          s2:='';
                          while pos('SCORES',f[posit[n1]^+w])=0 do
                             begin
                             if pos('ACCESSION',f[posit[n1]^+w])=1 then
                                s1:=trim(copy(f[posit[n1]^+w],13,80));
                             if pos('DEFINITION',f[posit[n1]^+w])=1 then
                                begin
                                s2:=trim(copy(f[posit[n1]^+w],13,80));
                                if pos('          ',f[posit[n1]^+w+1])<>0 then
                                   s2:=s2+' '+trim(f[posit[n1]^+w+1]);
                                end;
                             inc(w);
                             end;
                          end;
(*                           if (s1='') and (s2='') then     // seq. locales
                          begin
                          listbox1.items.add(' '); // 2eme ligne vide
                          w:=1;
                          while pos('SCORES',f[posit[n1]^+w])=0 do
                                inc(w);
                          listbox1.items.add('    '+trim(f[posit[n1]^+w+1]));
                          end
                       else
                          begin
                     //     listbox1.items.add(s1+' '+s2);
                         // scores
                     //     listbox1.items.add('    '+trim(f[posit[n1]^+w+1]));

                          end;
*)
                       //listbox1.items.add(' ');   //lign vide sparateur
                       end;
                 2:for n1:=1 to nseq do         //pearson
                       begin
                       itm:=lv.items.add;
                       itm.caption:=inttostr(n1);     //numro de la seq.
                       s:=f[posit[n1]^];    // '>>'
                       //si ligne suivante contient suite id alors concatner
                       if pos('init1:',f[posit[n1]^+1])=0 then
                          s:=s+' '+f[posit[n1]^+1];
 //                      itm.subitems.add(copy(s,3,255)); //1re ligne '>>' + 2me ligne
                       //lecture 1er mot (id seq)
                       //enleve '>>'
                       s:=copy(s,3,255);
                       //extrait ID   first word
                       id:=copy(s,1,pos(' ',s)-1);
                       //enleve id
                       delete(s,1,length(id));
                       s:=trim(s);
                       de:=s;
                       //extrait AC
                    (*   ac:=copy(s,1,pos(' ',s)-1);
                       compt_lettre:=0;
                       compt_chiffre:=0;
                       for t:=1 to length(ac) do
                           begin
                           if ac[t] in ['A'..'Z','a'..'z'] then
                              inc(compt_lettre);
                           if ac[t] in ['0'..'9'] then
                              inc(compt_chiffre);
                           end;
                       if ((compt_lettre=1) and (compt_chiffre=5)) or ((compt_lettre=2) and (compt_chiffre=6)) then
                          itm.subitems.add(ac)
                       else
                          itm.subitems.add(id);
                     *)
                       //ID
                       itm.subitems.Add(id);
                       //AC
                       itm.subitems.add('');  //ligne vide pour AC
                       //DE
                       itm.subitems.add(de);
                       w:=0;

                       repeat
                          if pos('initn',f[posit[n1]^+w])<>0 then
                             begin
                             //lecture Scores
                             init1:=lit_score('INIT1:',ansiuppercase(f[posit[n1]^+w]));
                             initn:=lit_score('INITN:',ansiuppercase(f[posit[n1]^+w]));
                             opt:=lit_score('OPT:',ansiuppercase(f[posit[n1]^+w]));
                             zscore:=lit_score('ZSCORE:',ansiuppercase(f[posit[n1]^+w]));
                             e:=lit_score('E():',ansiuppercase(f[posit[n1]^+w]));
                             end;
                          if pos('% identity ',f[posit[n1]^+w])<>0 then
                             begin
                             if pos('3.4',versionAlg)<>0 then
                                begin
                                //lit % homol
                                s:=trim(lit_score(';  ',ansiuppercase(f[posit[n1]^+w])));
                                itm.subitems.add(copy(s,1,pos('%',s)-1));
                                //lit longueur
                                itm.subitems.add(trim(lit_score(' IN ',ansiuppercase(f[posit[n1]^+w]))));
                                end
                             else
                                begin
                                //lit % homol
                                itm.subitems.add(trim(copy(f[posit[n1]^+w],1,pos('%',f[posit[n1]^+w])-1)));
                                //lit longueur
                                itm.subitems.add(trim(lit_score(' IN ',ansiuppercase(f[posit[n1]^+w]))));
                                end;
                             end;
                          inc(w);
                       until pos('% identity ',f[posit[n1]^+w-1])<>0
(*                           for nn:=1 to 3 do
                           begin
                           if (nn=1) and (pos('initn:',f[posit[n1]^+nn])=0) then
                              s:=s+f[posit[n1]^+nn];
                           if nn=1 then
                              listbox1.items.add(s);
                           if pos('initn:',f[posit[n1]^+nn])<>0 then
                              begin
                              s:='    '+f[posit[n1]^+nn];
                              listbox1.items.add(s);
                              end;
                           if pos('%',f[posit[n1]^+nn])<>0 then
                              begin
                              s:='    '+trim(f[posit[n1]^+nn]);
                              listbox1.items.add(s);
                              end;
                           end;
                       listbox1.items.add(' ');
*)
                       end;
                 end; {case}

end; //loadFASTA

//===========================================================================
procedure loadBLAST;
var w,n1:integer;
    ww:byte;
    ss:string;
begin
//reconnaissance fichier 'BLAST'
fastatype:=0;
blasttype:=0;
//controle si format HTML
flagHTML:=false;
for w:=0 to f.count-1 do
   if (pos('<HTML>',ansiuppercase(f[w]))<>0)
    or (pos('<HTTP://',ansiuppercase(f[w]))<>0) then
      begin
      flagHTML:=true;
      break;
      end;
if flagHTML then
  removeHTMLtag(f);

//reconnaissance format BLAST
for w:=0 to f.count-1 do
  if pos('BLAST',f[w])<>0 then
     begin
     blasttype:=1;
     //extraction version prog
     versionAlg:=f[w];
     break;
     end;
if blasttype=0 then
  begin
  showmessage('BLAST output not recognized!'#13#10'Check the BLAST output');
  exit;
  end;

//reconnaissance sequences
nseq:=0;
w:=0;
//positionement sur 1ere squence
while pos('Sequences producing significant alignments:',f[w])=0 do
  begin
  inc(w);
  if (pos('Query=',f[w])=1) then
     begin
     nq:=copy(f[w],8,maxint);
     //read query length
     //old BLAST <2.2.16
     for ww := 1 to 4 do
         begin
         (*
         if pos('(',f[w+ww])<>0 then
             begin
             s:=copy(f[w+ww],pos('(',f[w+ww])+1,80);  //ex. ______(24 letters)
             s:=copy(s,1,pos(' ',s)-1);  // cut "_letters"
             ls:=strtoint(s);
             end;
          *)
         //recent BLAST >=2.2.16
         if pos('Length=',f[w+ww])<>0 then
             begin
             s:=stringreplace(f[w+ww],'Length=','',[]);
             ls:=strtoint(s);
             end;
         end; //ww
     end;

  if w=f.count-1 then
     break;
  end;
//1ere seq non trouve
if w=f.count-1 then
  begin
  showmessage('First alignment not found!'+#10#13+'Check the BLAST output');
  exit;
  end;

while w<=f.count-1 do
  begin
  if (f[w]<>'') and (f[w][1]='>') then
     begin
     inc(nseq);
     new(posit[nseq]);
     posit[nseq]^:=w;
     end;
  inc(w);
  end; //new

new(posit[nseq+1]);
posit[nseq+1]^:=f.count;

//sequences visualisation
lv.items.clear;
for n1:=1 to nseq do
   begin
   itm:=lv.items.add;
   itm.caption:=inttostr(n1);
   s:=f[posit[n1]^];
   if pos('Length',f[posit[n1]^+1])=0 then
       s:=s+trim(f[posit[n1]^+1]);

   //DEFINITION
   de:=trim(copy(s,pos(' ',s)+1,maxint));

   //ID
   id:=copy(s,1,pos(' ',s)-1); //read first word from ">gi|124303521|gb|AY315197.2| Human herpesvirus 5 strain Towne, complete genome"
                               //id -> gi|124303521|gb|AY315197.2|

   id:=stringreplace(id,'>','',[]);
   itm.subitems.add(id);

   //extract AC
   ac:='';

   if pos('emb|',id)<>0 then
      ac:=copy(id,pos('emb|',id)+4,255);
   if pos('gb|',id)<>0 then
      ac:=copy(id,pos('gb|',id)+3,255);
   if pos('dbj|',id)<>0 then
      ac:=copy(id,pos('dbj|',id)+4,255);
   if pos('ref|',id)<>0 then
      ac:=copy(id,pos('ref|',id)+4,255);
   if pos('tpg|',id)<>0 then
      ac:=copy(id,pos('tpg|',id)+4,255);


   ac:=ac+'|';
   ac:=copy(ac,1,pos('|',ac)-1);
   itm.subitems.add(ac);
   //DE
   itm.subitems.add(de);

   //recherche  Identities =
   w:=1;
   while pos('Identities = ',f[posit[n1]^+w])=0 do
      inc(w);
   //extraction homol
   s:=copy(f[posit[n1]^+w],pos(' (',f[posit[n1]^+w])+2,255);
   itm.subitems.add(copy(s,1,pos('%',s)-1));

   //extraction longueur
   s:=copy(f[posit[n1]^+w],pos(' = ',f[posit[n1]^+w])+3,255);
   itm.subitems.add(copy(s,1,pos('/',s)-1));
   end;
end; //loadBLAST

//==========================================================================
begin //tfrmMain.load
opendialog1.title:='Open FASTA or BLAST output';
opendialog1.filter:='FASTA output (*.fas; *.fasta)|*.fas;*.fasta|BLAST output (*.blast; *.html)|*.blast; *.html|Text file (*.txt)|*.txt|All files (*.*)|*.*';
if not flagparam then
   begin
   if opendialog1.execute then
      nom_input:=opendialog1.filename
   else
      exit;
   end;
flagparam:=false;
if nom_input='' then
   exit;
nseq:=0;
Screen.Cursor:=crHourglass;
lv.items.BeginUpdate;
//load file on memory
f.loadfromfile(nom_input);
f.text:=AdjustLineBreaks(f.text);
align:='';
for w:=0 to f.count-1 do
    begin
    if (pos('(Nucleotide) FASTA',f[w])<>0)
       or (pos('(Peptide) FASTA',f[w])<>0)
       or (pos('FASTA searches a protein or DNA sequence data bank',f[w])<>0) then
       begin
       align:='FASTA';
       break;
       end;
    if pos('BLAST',f[w])<>0 then
       begin
       align:='BLAST';
       break;
       end;
    end;
if align='FASTA' then
   loadFASTA;
if align='BLAST' then
   loadBLAST;

lv.Items.EndUpdate;
Screen.Cursor:=crDefault;   
sb.panels[0].text:='Sequences number: '+inttostr(nseq);
sb.panels[1].text:='Selected: 0';

caption:='FASTA BLAST Scan - '+nom_input;
mi_SaveSelectedSequences.enabled:=true;
mi_SaveselectedsequencesinFASTACONVformat.enabled:=true;
Retrievemoreinfoforallsequences1.enabled:=true;
selection1.enabled:=true;
end;//load fasta


procedure fin;
var n1:word;
begin
if MessageDlg('Close FASTA BLAST Scan?',mtConfirmation,[mbYes,mbNo],0)=mrNo then
      exit;
f.free;
if (fastatype<>0) or (blasttype<>0) then
   for n1:=1 to nseq+1 do
       dispose(posit[n1]);
IniFile:=TIniFile.create(extractFilePath(application.exename)+'FASTA_BLAST_Scan.ini');
for n1:=0 to frmMain.lv.columns.count-1 do
    inifile.writeinteger('FASTA_BLAST_Scan','col'+inttostr(n1),frmMain.lv.columns[n1].Width);
inifile.free;

application.terminate;
end;

procedure TfrmMain.Quit1Click(Sender: TObject);
begin
fin;
end;

function checknumb(s:string):boolean;
var t:byte;
    flag:boolean;
begin
flag:=true;
for t:=1 to length(s) do
   if s[t] in ['a'..'z','A'..'Z','%','-','(',')'] then
      begin
      flag:=false;
      break;
      end;
checknumb:=flag;
end;

procedure TfrmMain.mi_SaveselectedsequencesClick(Sender: TObject);
var flagseqloc,flagtotrev,flagname,flaggap,flagrev:boolean;
    deb,n1:word;
    w,w1,w2:integer;
    ss,nomseq,rev_str,descr_str:shortstring;
    mem,s,s2,s3,memseq:string;
    ft:textfile;
    flagadd,flagfirstgi,flag_incl_gi:boolean;

label label1;

begin
//search for checked sequences
for w:=0 to lv.items.count-1 do
    if (lv.items[w].checked)  then
       begin
       n1:=1;
       break;
       end;
if n1=0 then
   begin
   showmessage('No selected sequences!');
   exit;
   end;

frmOptions.showmodal;
if frmOptions.modalresult=mrCancel then
   exit;

mem:='*';
n1:=0;
flagname:=false;
flaggap:=false;
memseq:='';

//======= FASTA ============================
Screen.Cursor := crHourglass;
if fastatype<>0 then
   begin
   flagtotrev:=false;
   f2:=Tstringlist.create;
   for w:=0 to lv.items.count-1 do
       begin
       if lv.items[w].checked then
          begin
          flagseqloc:=false;
          n1:=w+1;      // lecture numro seq.
          if (pos('/rev',f[posit[n1]^-3])<>0)
             or (pos('rev-comp ',f[posit[n1]^+1])<>0)
             or (pos('rev-comp ',f[posit[n1]^+2])<>0) then
             begin
             flagrev:=true;
             flagtotrev:=true;
             end
          else
             flagrev:=false;
          case fastatype of 1:begin      //GCG
                              if pos('ID',f[posit[n1]^])=1 then
                                 begin
                                 s:=copy(f[posit[n1]^],6,80);
                                 s:=uppercase(copy(s,1,pos(' ',s)-1));
                                 end
                               else
                               if pos('LOCUS',f[posit[n1]^])=1 then
                                 begin
                                 s:=copy(f[posit[n1]^],13,80);
                                 s:=uppercase(copy(s,1,pos(' ',s)-1));
                                 end
                               else //seq.locales
                                 begin
                                 flagseqloc:=true;
                                 s:=f[posit[n1]^];
                                 end;
                               end;
                            2:begin        // PEARSON FASTA
                              s:=uppercase(trim(copy(f[posit[n1]^],3,13))); //AC
                              s:=s+'  '+copy(f[posit[n1]^],16,255);
                              if f[posit[n1]^+1][1]<>' ' then //option -L "more info"
                                 s:=s+' '+f[posit[n1]^+1];
                              end;
                            end;//case
          //

          if lv.items[w].subitems.count>0 then
             begin
             if lv.items[w].subitems.strings[1]<>'' then //AC
                 nomseq:=lv.items[w].subitems.strings[1]  //AC
             else
                 nomseq:=lv.items[w].subitems.strings[0];  //ID
             end
          else
             nomseq:='SEQUENCE_NAME_ERROR';
          //modification nom seq en cas d'homonymie
          while pos('*'+nomseq+'*',mem)<>0 do
             begin
             nomseq:=nomseq+'_';
             flagname:=true;
             end;

          mem:=mem+nomseq+'*';
          if flagseqloc then   //seq locales
             begin
             w1:=1;
             s2:='';
             while posit[n1]^+w1<posit[n1+1]^ do
                begin
                if (f[posit[n1]^+w1]<>'') and checknumb(f[posit[n1]^+w1]) and (f[posit[n1]^+w1+1]<>'') then
                   begin
                   inc(w1,3);
                   deb:=1;
                   // saute ID seq
                   while f[posit[n1]^+w1][deb]<>' ' do
                      inc(deb);
                   // saute espaces
                   while f[posit[n1]^+w1][deb]=' ' do
                      inc(deb);
                   for w2:=deb to length(f[posit[n1]^+w1-2]) do
                       if pos(f[posit[n1]^+w1-2][w2],' 0123456789')=0 then
                          s2:=s2+f[posit[n1]^+w1][w2];
                   end;
                inc(w1);
                end;
             end
          else        // EMBL ou GB
             begin
             s:=copy(s,1,6);
             while length(s)<6 do
                s:=s+' ';
             w1:=1;
             s2:='';
             while posit[n1]^+w1<posit[n1+1]^ do
                   begin
                   if trim(uppercase(copy(f[posit[n1]^+w1],1,6)))=trim(copy(s,1,pos('@',s+'@')-1)) then
                      begin
                      deb:=1;
                      // saute ID seq
                       while f[posit[n1]^+w1][deb]<>' ' do
                             inc(deb);
                       // saute espaces
                       while f[posit[n1]^+w1][deb]=' ' do
                             inc(deb);

                       for w2:=deb to length(f[posit[n1]^+w1-2]) do
                           if pos(f[posit[n1]^+w1-2][w2],' 0123456789')=0 then
                              s2:=s2+f[posit[n1]^+w1][w2];
                       end;
                 inc(w1);
                 end;
             end; //else

       // retire blanc de la sq.
       while pos(' ',s2)<>0 do
          delete(s2,pos(' ',s2),1);
       // check gap
       if not flaggap and (pos('-',s2)<>0) then
          flaggap:=true;
       s3:='';
       if flagrev then
          begin
          for w2:=length(s2) downto 1 do
                  case s2[w2] of 'A':s3:=s3+'T';
                                 'C':s3:=s3+'G';
                                 'G':s3:=s3+'C';
                                 'T':s3:=s3+'A';
                                 'M':s3:=s3+'K';
                                 'R':s3:=s3+'Y';
                                 'S':s3:=s3+'S';
                                 'V':s3:=s3+'B';
                                 'W':s3:=s3+'W';
                                 'Y':s3:=s3+'R';
                                 'H':s3:=s3+'D';
                                 'K':s3:=s3+'M';
                                 'D':s3:=s3+'H';
                                 'B':s3:=s3+'V';
                                 'N':s3:=s3+'N';
                                 end;
          s2:=s3;
          end;

       if flagrev then
          rev_str:=' /rev  '
       else
          rev_str:='  ';
       if frmOptions.cbIncludeDescription.Checked then
          descr_str:=lv.items[w].subitems.strings[2]; //DE

       if (frmOptions.cbSaveUniqueSequence.Checked) then
          begin
          if pos(s2,memseq)=0 then
             begin
             // nom seq
             f2.add('>'+nomseq+rev_str+descr_str);
             //seq
             f2.add(s2);
             memseq:=memseq+'*'+s2+'*';
             end;
          end
       else
          begin
          // nom seq
          f2.add('>'+nomseq+rev_str+descr_str);
          //sequence
          f2.add(s2);
          end;
       end;
    end;
   end; // fasta

(*======= BLAST ==============================================*)
if blasttype<>0 then
   begin
   flagfirstgi:=true;
   flagtotrev:=false;
   memseq:='';
   f2:=Tstringlist.create;
   for w:=0 to lv.items.count-1 do
       begin
       if lv.Items[w].checked then
          begin
          // position sequence ds fichier
          n1:=w+1;
          //extraction sequence
          w1:=1;
          label1:
          if lv.items[w].subitems.count>0 then
              begin
              if lv.Items[w].SubItems.strings[1]<>'' then
                  nomseq:=lv.Items[w].SubItems.strings[1]   //AC
              else
                  nomseq:=lv.Items[w].SubItems.strings[0];   //ID
              end
          else
              nomseq:='SEQUENCE_NAME_ERROR';
          while pos('*'+nomseq+'*',mem)<>0 do
             begin
             nomseq:=nomseq+'_';
             flagname:=true;
             end;
          mem:=mem+nomseq+'*';
          s2:='';
          while (posit[n1]^+w1<posit[n1+1]^) do      { TODO : BUG: sequence double! }
                begin
                //check if seq rev
                if pos('Strand = Plus / Plus',f[posit[n1]^+w1])<>0 then
                   flagrev:=false;
                if pos('Strand = Plus / Minus',f[posit[n1]^+w1])<>0 then
                   begin
                   flagrev:=true;
                   flagtotrev:=true;
                   end;

                if copy(f[posit[n1]^+w1],1,5)='Query' then
                   begin
                   deb:=1;
                   // saute ID seq
                   while f[posit[n1]^+w1][deb]<>' ' do
                         inc(deb);
                   // saute espaces
                   while f[posit[n1]^+w1][deb]=' ' do
                         inc(deb);

                   for w2:=deb to length(f[posit[n1]^+w1]) do
                       if pos(f[posit[n1]^+w1][w2],' 0123456789')=0 then
                          s2:=s2+f[posit[n1]^+w1+2][w2];
                   if not flaggap and (pos('-',s2)<>0) then
                      flaggap:=true;
                   end;
                inc(w1);
                if posit[n1]^+w1>=f.count-1 then
                   break;
                if (pos('Score =',f[posit[n1]^+w1])<>0) and (s2<>'') then
                   break;
                end;
          //write seq
          if flagrev then
             rev_str:=' /rev'
          else
             rev_str:='';

          if frmOptions.cbIncludeDescription.Checked then
             descr_str:=lv.items[w].subitems.strings[2]; //DE

          if (frmOptions.cbSaveUniqueSequence.Checked) then
              begin
              if pos(s2,memseq)=0 then
                 begin
                 // nom seq
                 if frmOptions.cbIncludeDescription.Checked then
                      f2.add('>'+nomseq+rev_str+'  '+descr_str)
                 else
                      f2.add('>'+nomseq+rev_str);
                 //seq
                 f2.add(s2);
                 end;
              memseq:=memseq+'*'+s2+'*';
              end
           else
              begin
              // nom seq
              f2.add('>'+nomseq+rev_str+'  '+descr_str);
              //sequence
              f2.add(s2);
              end;

          if (pos('Score =',f[posit[n1]^+w1])<>0) and (s2<>'') then
             begin
             goto label1;

             end;
          end; //if checked
       end; //for
   end; //blasttype

Screen.Cursor:=crDefault;

savedialog1.filename:=changefileext(nom_input,'.fst');
if savedialog1.execute then
   begin
   flagadd:=false;
   if fileexists(savedialog1.filename) then
      begin
      frmWarning.showmodal;
      if frmWarning.modalresult=mrcancel then
         exit;
      if frmWarning.modalresult=mrno then
         flagadd:=true
      else
         flagadd:=false;
      end;
   if flaggap then
      if MessageDlg('Some sequences contain gaps ''-''. Remove gaps from sequences?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
         for n1:=0 to f2.count-1 do
             if f2[n1][1]<>'>' then
                begin
                s:=f2[n1];
                while pos('-',s)<>0 do
                   delete(s,pos('-',s),1);
                f2[n1]:=s;
                end;
   if not flagadd then
      f2.savetofile(savedialog1.filename)   //crase si fichier prsent
   else
      begin
      assignfile(ft,savedialog1.filename);  //ajoute seq si fichier prsent
      append(ft);
      for n1:=0 to f2.count-1 do
          writeln(ft,f2[n1]);
      closefile(ft);
      end;
   if flagtotrev then
      showmessage('Some sequences were complemented and reverted to be in the same sense that query sequence');
   if flagname then
      showmessage('Some sequence names were modified (concatenated "_" character) to avoid same sequence name');
   end;
mem:='';
f2.free;
end;  //save selected seq.


procedure TfrmMain.SUS1Click(Sender: TObject);
begin
frmSelect.Top:=0;
frmSelect.left:=0;
frmSelect.show;
end;

procedure TfrmMain.Info1Click(Sender: TObject);
begin
if (fastatype=0) and (blasttype=0) then
    showmessage('No alignment!')
else
    showmessage(copy('FASTA Output from GCG Package',1,255*byte(fastatype=1))+
                copy('FASTA Output from Pearson Package',1,255*byte(fastatype=2))+
                copy('BLAST Output',1,255*byte(blasttype=1))+#10+
                versionAlg+#10+
                'File name: '+nom_input+#10+
                'Query name: '+nq+#10+
                'Query length: '+inttostr(ls)+#10+
                'Number of sequences: '+inttostr(nseq));

end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action := caNone;
fin;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var i:integer;
begin
caption:=program_name+' - '+version_number+' ('+version_date+')';
IniFile:=Tinifile.create(extractFilePath(application.exename)+'FASTA_BLAST_Scan.ini');
for i:=0 to lv.Columns.count-1 do
    lv.Columns[i].Width:=inifile.readinteger('FASTA_BLAST_Scan','col'+inttostr(i),100);
inifile.free;
decimalseparator:='.';
mi_saveselectedsequences.enabled:=false;
mi_SaveselectedsequencesinFASTACONVformat.enabled:=false;
Retrievemoreinfoforallsequences1.enabled:=false;
flagparam:=false;
f:=Tstringlist.create;
end;


procedure TfrmMain.MenuItem1Click(Sender: TObject);
var w:integer;
begin
if lv.Items.count>0 then
   for w:=0 to lv.items.count-1 do
       if lv.Items[w].selected then
          lv.Items[w].Checked:=true;
end;

procedure TfrmMain.MenuItem2Click(Sender: TObject);
var w:integer;
begin
if lv.Items.count>0 then
   for w:=0 to lv.items.count-1 do
       if lv.Items[w].selected then
          lv.Items[w].Checked:=false;
end;          

procedure TfrmMain.FormShow(Sender: TObject);
begin
if paramcount<>0 then
   begin
   flagparam:=true;
   nom_input:=paramstr(1);
   Load(self);
   end;
end;

procedure TfrmMain.lvClick(Sender: TObject);
begin
compte;
end;

procedure TfrmMain.Selectallsequences1Click(Sender: TObject);
var w:integer;
begin //select all
if MessageDlg('Select all sequences?',mtConfirmation,[mbYes, mbNo],0)=mrYes then
   if lv.items.count>0 then
      for w:=0 to lv.items.count-1 do
          lv.items[w].checked:=true;
sb.panels[1].text:='Selected: '+inttostr(nseq);
end;

procedure TfrmMain.Unselectallsequences1Click(Sender: TObject);
var w:integer;
begin  //deselect all
if MessageDlg('Deselect all sequences?',mtConfirmation,[mbYes, mbNo],0)=mrYes then
   if lv.items.count>0 then
      for w:=0 to lv.items.count-1 do
          lv.items[w].checked:=false;
sb.panels[1].text:='Selected: 0';
end;

procedure TfrmMain.Invertselection1Click(Sender: TObject);
var w:integer;
begin
if lv.items.count>0 then
   for w:=0 to lv.items.count-1 do
       if lv.items[w].checked then
          lv.items[w].checked:=false
       else
          lv.items[w].checked:=true;
compte;
end;

procedure TfrmMain.RetrieveInfoSelSeq(Sender: TObject);
var s,id,def,ac,src:shortstring;
    t1:integer;
    sl:tstringlist;
begin
if frmMain.lv.selected=nil then
   exit;

sl:=tstringlist.Create;
id:=frmMain.lv.selected.subitems.strings[0];
frmMain.sb.panels[2].Text:='Retrieving information for '+id;
Screen.Cursor:=crHourglass;
application.ProcessMessages;

s:='http://www.ebi.ac.uk/cgi-bin/emblfetch?id='+id;
//   s:='http://www.ncbi.nlm.nih.gov/htbin-post/Entrez/query?db=n&form=6&uid='+id+'&dopt=g&tool=EntrezLinkDoc&html=no';

sl.text:=AdjustLineBreaks(frmMain.idHTTP1.get(s));
def:='';
for t1:=0 to sl.count-1 do
    begin
    if pos('DE',sl[t1])=1 then
       def:=def+copy(sl[t1],6,255)+' ';
    if pos('AC',sl[t1])=1 then
       begin
       ac:=copy(sl[t1],6,255);
       while pos(';',ac)<>0 do
          delete(ac,pos(';',ac),1);
       end;
    if pos('OS',sl[t1])=1 then
       src:=copy(sl[t1],6,255);
    end;

frmMain.sb.panels[2].Text:=ac;
frmMain.lv.selected.subitems.strings[1]:=ac;
frmMain.lv.selected.subitems.strings[2]:=def;
sl.Free;
Screen.Cursor:=crDefault;
end; //retrieve information from server



function rev(s:string):string;
var i:integer;
    s3:string;
begin
s3:='';
for i:=length(s) downto 1 do
      case s[i] of '-':s3:=s3+'-';
                   ' ':s3:=s3+' ';
                   'A':s3:=s3+'T';
                   'C':s3:=s3+'G';
                   'G':s3:=s3+'C';
                   'T':s3:=s3+'A';
                   'M':s3:=s3+'K';
                   'R':s3:=s3+'Y';
                   'S':s3:=s3+'S';
                   'V':s3:=s3+'B';
                   'W':s3:=s3+'W';
                   'Y':s3:=s3+'R';
                   'H':s3:=s3+'D';
                   'K':s3:=s3+'M';
                   'D':s3:=s3+'H';
                   'B':s3:=s3+'V';
                   'N':s3:=s3+'N';
                   end;
result:=s3;
end;  //rev

procedure Lalign(var s:string; b:byte);
begin
s:=s+dupestring(' ',b-length(s));
end;

procedure TfrmMain.mi_SaveselectedsequencesinFASTACONVformatClick(
  Sender: TObject);

const validbase='ACGTUYRWSKMBDHVN-';
      tabseq=104;

var flagseqloc,flagtotrev,flagname,flaggap:boolean;
    deb,n1:word;
    s0,nomseq,nomquery:string;
    s4,s5,q,seqquery,mem,s,s2:string;
    ft:textfile;
    flagadd,flagfirstgi,flag_incl_gi,flagL,flagrev:boolean;
    w,w1,w2:integer;
begin
if blasttype<>0 then
    begin
    showmessage('This output is not yet implemented for BLAST results...');
    exit;
    end;

mem:='*';
n1:=0;
flagname:=false;
flaggap:=false;
//recherche si seq slectiones
for w:=0 to lv.items.count-1 do
    if (lv.items[w].checked)  then
       begin
       n1:=1;
       break;
       end;
if n1=0 then
   begin
   showmessage('No selected sequences!');
   exit;
   end;

//======= FASTA ============================
Screen.Cursor := crHourglass;
if fastatype<>0 then
   begin
   flagtotrev:=false;
   f2:=Tstringlist.create;
   //extrait seq query
   seqquery:='';

   flagL:=true;
   if pos('initn:',f[posit[1]^+1])<>0 then //option -L "more info"
      flagL:=false;

   if flagL then //option -L "more info"
      w:=posit[1]^+6
   else
      w:=posit[1]^+5;

   nomquery:=copy(f[w],1,pos(' ',f[w])-1);
   repeat
       if copy(f[w],1,pos(' ',f[w])-1)=nomquery then
          begin
          seqquery:=seqquery+copy(f[w],length(nomquery)+1,255);
          inc(w,2);
          end;
       inc(w);
   until w>=posit[2]^;

   //delete space char.
   seqquery:=trim(seqquery);
   while pos(' ',seqquery)<>0 do
       delete(seqquery,pos(' ',seqquery),1);

   //rev. seq
   if (pos('rev-comp',f[posit[1]^+1])<>0) or (pos('rev-comp',f[posit[1]^+2])<>0) then
      seqquery:=rev(seqquery);

   Lalign(nomquery,tabseq);

   f2.add(nomquery+seqquery);

   for w:=0 to lv.items.count-1 do
       begin
       if lv.items[w].checked then
          begin
          flagseqloc:=false;
          n1:=w+1;      // lecture numro seq.
          if (pos('/rev',f[posit[n1]^-3])<>0)
             or (pos('rev-comp ',f[posit[n1]^+1])<>0)
             or (pos('rev-comp ',f[posit[n1]^+2])<>0) then
             begin
             flagrev:=true;
             flagtotrev:=true;
             end
          else
             flagrev:=false;
          case fastatype of 1:begin      //GCG
                              if pos('ID',f[posit[n1]^])=1 then
                                 begin
                                 s:=copy(f[posit[n1]^],6,80);
                                 s:=uppercase(copy(s,1,pos(' ',s)-1));
                                 end
                              else
                               if pos('LOCUS',f[posit[n1]^])=1 then
                                 begin
                                 s:=copy(f[posit[n1]^],13,80);
                                 s:=uppercase(copy(s,1,pos(' ',s)-1));
                                 end
                               else //seq.locales
                                 begin
                                 flagseqloc:=true;
                                 s:=f[posit[n1]^];
                                 end;
                               end;
                            2:begin        // PEARSON FASTA
                              s:=uppercase(copy(f[posit[n1]^],1,pos(' ',f[posit[n1]^])));
                              delete(s,1,2); //efface ">>"
                              s:=s+' '+copy(f[posit[n1]^],14,255);
                              if flagL then //option -L "more info"
                                 begin
                                 s:=s+' '+f[posit[n1]^+1];
                                 //restriction en longeur
                                 s4:=f[posit[n1]^+2];  //initn: 115 init1: 115 opt: 115
                                 s5:=f[posit[n1]^+3];  //banded Smith-Waterman score: 115;  100.000% identity (100.000% ungapped) in 23 nt overlap (1-23:15354-15376)
                                 end
                              else
                                 begin
                                 s4:=f[posit[n1]^+1];  //initn: 115 init1: 115 opt: 115
                                 s5:=f[posit[n1]^+2];  //banded Smith-Waterman score: 115;  100.000% identity (100.000% ungapped) in 23 nt overlap (1-23:15354-15376)
                                 end;
                              end;
                            3:begin  //SSEARCH
                              s:=uppercase(trim(copy(f[posit[n1]^],3,13))); //AC
                              s:=s+'  '+copy(f[posit[n1]^],16,255);
                              if flagL then //option -L "more info"
                                 begin
                                 s:=s+' '+f[posit[n1]^+1];
                                 s4:=f[posit[n1]^+2];
                                 s5:=f[posit[n1]^+3];
                                 end
                              else
                                 begin
                                 s4:=f[posit[n1]^+1];
                                 s5:=f[posit[n1]^+2];
                                 end;
                              end;
                            end;//case

          if lv.items[w].subitems.count>2 then
             nomseq:=lv.items[w].subitems.strings[0]
          else
             nomseq:='SEQUENCE_NAME_ERROR';
          //modification nom seq en cas d'homonymie
          while pos('*'+nomseq+'*',mem)<>0 do
             begin
             nomseq:=nomseq+'_';
             flagname:=true;
             end;

          mem:=mem+nomseq+'*';
          if flagseqloc then   //seq locales
             begin
             w1:=1;
             s2:='';
             while posit[n1]^+w1<posit[n1+1]^ do
                begin
                if (f[posit[n1]^+w1]<>'') and checknumb(f[posit[n1]^+w1]) and (f[posit[n1]^+w1+1]<>'') then
                   begin
                   inc(w1,3);
                   deb:=1;
                   // saute ID seq
                   while f[posit[n1]^+w1][deb]<>' ' do
                      inc(deb);
                   // saute espaces
                   while f[posit[n1]^+w1][deb]=' ' do
                      inc(deb);
                   for w2:=deb to length(f[posit[n1]^+w1-2]) do
                       if pos(f[posit[n1]^+w1-2][w2],validbase)<>0 then
                          s2:=s2+f[posit[n1]^+w1][w2];
                   end;
                inc(w1);
                end;
             end
          else        // EMBL ou GB
             begin
             s:=copy(lv.items[w].subitems.strings[0],1,6);
             Lalign(s,6);
             w1:=1;
             s2:='';
             q:='';
             while posit[n1]^+w1<posit[n1+1]^ do
                   begin
                   if trim(uppercase(copy(f[posit[n1]^+w1],1,6)))=trim(uppercase(copy(s,1,pos('@',s+'@')-1))) then
                      begin


                      // skip seq ID
                      (*
                      deb:=0;
                      repeat
                        inc(deb);
                      until f[posit[n1]^+w1][deb]=' ';
                      *)

                      deb:=8;

                      for w2:=deb to length(f[posit[n1]^+w1-2]) do
                          if pos(f[posit[n1]^+w1-2][w2],validbase)<>0 then
                             begin
                             s2:=s2+f[posit[n1]^+w1][w2];
                             q:=q+f[posit[n1]^+w1-2][w2];
                             end;
                      end;
                   inc(w1);
                   end;

             end; //else

       s0:=lv.items[w].subitems.strings[0];

       if flagrev then
          begin
          s0:=s0+' /rev';
          s2:=rev(s2);
          q:=rev(q);
          end;

       Lalign(s0,16);

       s0:=s0+'  '+lv.items[w].subitems.strings[2];

       if length(s0)>100 then
          s0:=copy(s0,1,98)+'..';

       Lalign(s0,tabseq);

       //clean seq vs query
       for w2:=1 to length(q) do
           begin
           if s2[w2]=q[w2] then
              s2[w2]:='.';
           if q[w2]='-' then
              s2[w2]:=chr(ord(s2[w2])+32);
           end;

       Lalign(s2,length(seqquery));

       f2.add(s0+s2+'    '+lv.items[w].subitems.strings[3]);
       end;
    end;

   //header
   f2.insert(0,'');

   for w:=11 downto 0 do
       f2.Insert(0,f[w]);

   f2.insert(0,'');
   f2.insert(0,'FASTA BLAST scan '+version_number+' (output: query-anchored format)');

   //end of file
   f2.add('');
   for w:=f.Count-7 to f.Count-1 do
       f2.add(f[w]);
   end; //fasta

Screen.Cursor := crDefault;

savedialog1.filename:=changefileext(nom_input,'.fbs');
if savedialog1.execute then
   begin
   flagadd:=false;
   if fileexists(savedialog1.filename) then
      begin
      frmWarning.showmodal;
      if frmWarning.modalresult=mrcancel then
         exit;
      if frmWarning.modalresult=mrno then
         flagadd:=true
      else
         flagadd:=false;
      end;

   if not flagadd then
      f2.savetofile(savedialog1.filename)   //crase si fichier prsent
   else
      begin
      assignfile(ft,savedialog1.filename);  //ajoute seq si fichier prsent
      append(ft);
      for n1:=0 to f2.count-1 do
          writeln(ft,f2[n1]);
      closefile(ft);
      end;
   end;
mem:='';
f2.free;
end;


procedure TfrmMain.Retrievemoreinfoforallsequences1Click(Sender: TObject);
var s,id,def,ac,src:shortstring;
    t1,t:integer;
    sl:tstringlist;
begin
//frmRetrieve.show;
Screen.Cursor:=crHourglass;
for t:=0 to lv.items.count-1 do
    begin

    sl:=tstringlist.Create;
    id:=frmMain.lv.items[t].subitems.strings[1];
    frmMain.sb.panels[2].Text:='Retrieving information for '+id;
    application.ProcessMessages;

    s:='http://www.ebi.ac.uk/cgi-bin/emblfetch?id='+id;
//   s:='http://www.ncbi.nlm.nih.gov/htbin-post/Entrez/query?db=n&form=6&uid='+id+'&dopt=g&tool=EntrezLinkDoc&html=no';

    //showmessage(s);

    sl.text:=AdjustLineBreaks(frmMain.idHTTP1.get(s));
    def:='';
    for t1:=0 to sl.count-1 do
        begin
        if pos('DE',sl[t1])=1 then
           def:=def+copy(sl[t1],6,255)+' ';
        if pos('AC',sl[t1])=1 then
           begin
           ac:=copy(sl[t1],6,255);
           while pos(';',ac)<>0 do
              delete(ac,pos(';',ac),1);
           end;
        if pos('OS',sl[t1])=1 then
           src:=copy(sl[t1],6,255);
        end;

    frmMain.sb.panels[2].Text:=ac;
    frmMain.lv.items[t].subitems.strings[1]:=ac;
    frmMain.lv.items[t].subitems.strings[2]:=def;
    sl.Free;
    end; //for t
Screen.Cursor:=crDefault;
end; //retrieve information from server


end.
